
#include <RFduinoBLE.h> 
#include <DallasTemperature.h>
#include <OneWire.h>
#include <PString.h>
#define ONEWIRE_BUS 2
#define PIN 5
#define RELAY 3
#define SENSORPIN 4

OneWire oneWire(ONEWIRE_BUS);
DallasTemperature sensors(&oneWire);

//consigne
double consTmp=23;  

//detection mouvement
int detect1=0;
int detect2=0;
//compteur pour alerter que la personne n'a pas bouge
int cpt=0;
//variable pour la commande de LEDS
char item1[6];
char item2[6];
char item3[6] ;
char envoi[20];
PString mystring(envoi, sizeof(envoi));
const int ws2812pin = 5;
const int nPIXELS = 4;
const int nLEDs = nPIXELS * 3;
uint8_t ledBar[nLEDs];



void setup() {
 
  Serial.begin(9600);
  Serial.println("Serial rate set to 9600 baud");
  pinMode(ws2812pin, OUTPUT);
  pinMode(RELAY,OUTPUT);
  digitalWrite(ws2812pin, LOW);
  // Eteint toutes les LEDS
  for(int wsOut = 0; wsOut < nLEDs; wsOut++){
    ledBar[wsOut] = 0x00;
  }
  loadWS2812();  
  delay(1);   
  sensors.begin();
  RFduinoBLE.begin();
  timer_config();
  Serial.println("RFduino en marche");
  
  

}

void loop() {
    RFduino_ULPDelay(3000);
    if(cpt>=3){
      RFduinoBLE.send("Alerte",6);
      Serial.println("IL A PAS BOUGE");
      cpt=0;
    }
    if(abs(detect2-detect1) >= 15) {
       RFduinoBLE.send("Mouvement",9);
       Serial.println("Mouvement !");
       cpt=0; 
    }
      
    

}



void timer_config(void)
{
  NRF_TIMER1->TASKS_STOP = 1;   // Stop timer
  NRF_TIMER1->MODE = TIMER_MODE_MODE_Timer;  // taken from Nordic dev zone
  NRF_TIMER1->BITMODE = (TIMER_BITMODE_BITMODE_16Bit << TIMER_BITMODE_BITMODE_Pos);
  NRF_TIMER1->PRESCALER = 14;   // SysClk/2^PRESCALER) =  16,000,000/16 = 1us resolution
  NRF_TIMER1->TASKS_CLEAR = 1; // Clear timer
  NRF_TIMER1->CC[0] = 60000; // Cannot exceed 16bits
  NRF_TIMER1->INTENSET = TIMER_INTENSET_COMPARE0_Enabled << TIMER_INTENSET_COMPARE0_Pos;  // taken from Nordic dev zone
  NRF_TIMER1->SHORTS = (TIMER_SHORTS_COMPARE0_CLEAR_Enabled << TIMER_SHORTS_COMPARE0_CLEAR_Pos);
}


void RFduinoBLE_onConnect()
{
  Serial.println("RFduino BLE connection successful");
  attachInterrupt(TIMER1_IRQn, TIMER1_Interrupt);
  NRF_TIMER1->TASKS_START = 1;   // Start TIMER
  

  
}

void RFduinoBLE_onDisconnect()
{
  Serial.println("RFduino BLE disconnected");
  digitalWrite(RELAY,LOW);
   // On desactive le timer
  NRF_TIMER1->TASKS_STOP = 1;
  detachInterrupt(TIMER1_IRQn);
 
  
}


void RFduinoBLE_onReceive(char *data, int len)
{
  if(strstr(data, "temp")!=NULL ){
    sensors.requestTemperatures();
    float temperature=sensors.getTempCByIndex(0);
    mystring.print(temperature);
    Serial.println(mystring);
    //RFduinoBLE.sendFloat(temperature);
    RFduinoBLE.send(mystring,30);
    mystring="";
  }
  else if(strstr(data, "rouge")!=NULL && strchr(data,':')==NULL) {
  clear();
     for(int wsOut = 1; wsOut < nLEDs; wsOut+=3){ // red
        ledBar[wsOut] = 0xff;
        loadWS2812();
     }
  }
  else if(strstr(data, "vert")!=NULL && strchr(data,':')==NULL) {
     clear();
    for(int wsOut = 0; wsOut < nLEDs; wsOut+=3){ // green
       ledBar[wsOut] = 0xff;
       loadWS2812();
    }
  }
  else if(strstr(data, "bleu")!=NULL && strchr(data,':')==NULL) {
      clear();
      for(int wsOut = 2; wsOut < nLEDs; wsOut+=3){ // blue
        ledBar[wsOut] = 0xff;
        loadWS2812();
      }
  }
  else
  {
    if(strstr(data,"consigne") != NULL)
    {
      char* token = strtok(data,"=");
      token = strtok(NULL,"");
      consTmp=atof(token);  
    }
    else if (strchr(data,':')==NULL)
    {
      item1[0]= data[0];
      item1[1]= data[1];
      item2[0]= data[2];
      item2[1]= data[3];
      item3[0]= data[4];
      item3[1]= data[5];
	  
	  clear();
	  for(int wsOut = 1; wsOut < nLEDs; wsOut+=3){ // red
        ledBar[wsOut] = strtoul(item1,NULL,16);
        loadWS2812();
		}
	  for(int wsOut = 0; wsOut < nLEDs; wsOut+=3){ // green
		ledBar[wsOut] = strtoul(item2,NULL,16);
		loadWS2812();
		}
	  for(int wsOut = 2; wsOut < nLEDs; wsOut+=3){ // blue
		ledBar[wsOut] = strtoul(item3,NULL,16);
		loadWS2812();
		}
    }
    else
    {
      int nbre = atoi(&data[0]);
      char* token = strtok(data,":");
      token = strtok(NULL,"");
      
	  clear_one(nbre);
	  
      if(strstr(token,"rouge")!=NULL) {
		ledBar[3*nbre-2]=0xff;
      }
      else if (strstr(token,"vert")!=NULL) {
        ledBar[3*nbre-3]=0xff;
      }
      else if (strstr(token,"bleu")!=NULL) {
        ledBar[3*nbre-1]=0xff;
      }
      else {
        item1[0]= data[2];
        item1[1]= data[3];
        item2[0]= data[4];
        item2[1]= data[5];
        item3[0]= data[6];
        item3[1]= data[7];      
		
		ledBar[3*nbre-2]=strtoul(item1,NULL,16);
		ledBar[3*nbre-3]=strtoul(item2,NULL,16);
		ledBar[3*nbre-1]=strtoul(item3,NULL,16);    
      }
      loadWS2812();
    }
  }
}

void loadWS2812(){
  
  noInterrupts();

  for(int wsOut = 0; wsOut < nLEDs; wsOut++){
    for(int x=7; x>=0; x--){
      NRF_GPIO->OUTSET = (1UL << ws2812pin);
      if(ledBar[wsOut] & (0x01 << x)) {
        __ASM ( \
              " NOP\n\t" \
              " NOP\n\t" \
              " NOP\n\t" \
              " NOP\n\t" \
              " NOP\n\t" \
              );
        NRF_GPIO->OUTCLR = (1UL << ws2812pin);
      
      }else{
        NRF_GPIO->OUTCLR = (1UL << ws2812pin);
        __ASM ( \
              " NOP\n\t" \
              " NOP\n\t" \
              " NOP\n\t" \
              );      
      }
    }
  }
  delayMicroseconds(50); // latch and reset WS2812.
  interrupts();  
}

void clear(){
 for(int i=0; i<3 ; i++){
  for(int wsOut = i; wsOut < nLEDs; wsOut+=3){ 
    
    ledBar[wsOut] = 0x00;
    loadWS2812();
  }
 }

}

void clear_one(int nombre) {
	for(int i=0; i<3; i++) {
		ledBar[3*(nombre-1)+i] = 0x00;
		loadWS2812();
		}
}

void pulseRelay(int pin){
  sensors.requestTemperatures();
  double temperature=sensors.getTempCByIndex(0);
  mystring.print(temperature);
  Serial.println(mystring);
  
  if(temperature>consTmp){
    digitalWrite(pin,HIGH);
  }
  else {
    digitalWrite(pin,LOW);
  }
  mystring="";
} 


void TIMER1_Interrupt(void)
{
  if (NRF_TIMER1->EVENTS_COMPARE[0] != 0)
  {
    // gestion de la temperature
    pulseRelay(RELAY);
    mouvement();
    NRF_TIMER1->EVENTS_COMPARE[0] = 0;
  }
}
void mouvement(){ 
  cpt++;
  detect2 = detect1;
  detect1 = analogRead(SENSORPIN);
}


/*void TIMER2_Interrupt(void)
{
  if (NRF_TIMER2->EVENTS_COMPARE[0] != 0)
  {
    // Alerte PAS DE MVT
     //RFduinoBLE.send("Alerte",sizeof("Aterte"));
     Serial.println("IL A PAS BOUGE");
    NRF_TIMER1->EVENTS_COMPARE[0] = 0;
  }
}*/
